Attribute VB_Name = "modMain"
Option Explicit
Const MAX_MEMBERS = 1000
Public Const GWL_HWNDPARENT = (-8)
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
    (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, _
                     ByVal lpOperation As String, ByVal lpFile As String, _
                     ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long



Public Sub MenuInsertErrorHandlerClick()
    On Error GoTo errHandler
    Dim Cancelled As Boolean
    Check Not (ActiveModule Is Nothing), EXC_GENERAL, "No active module."
    ReadProjectName
    RefreshModuleInfo
    If CheckCanInsert Then InsertErrorHandler False
    InitProcInfo
    Exit Sub
errHandler:
    ErrorIn "modMain.MenuInsertErrorHandlerClick"
End Sub

Public Sub MenuSettingsClick()
    On Error GoTo errHandler
    ReadProjectName
    RefreshModuleInfo
    InitProcInfo
    ReadCurrentProcInfo ProcName, procType, procIsHandler, procStartLine, procLineCount, procText
    frmSettings.ShowSettings
    Exit Sub
errHandler:
    ErrorIn "modMain.MenuSettingsClick"
End Sub

Public Function CheckCanInsert() As Boolean
    On Error GoTo errHandler
    Dim InHuntERRProject As Boolean, InTestModule As Boolean, CanNotInsert As Boolean
    InHuntERRProject = (LCase(ideProjectName) = LCase("HuntERRAddIn"))
    InTestModule = (InStr(1, ideModuleName, "TESTCODE") > 0)
    CanNotInsert = InHuntERRProject And (Not InTestModule)
    If CanNotInsert Then
        Say "You are trying to use HuntERR Add-In functions in Add-In's source project.  " & vbNewLine & _
            "To prevent breaking add-in source code you can do it only in module " & vbNewLine & _
            "with name containing TESTCODE"
        Else
        CheckCanInsert = True
    End If
    Exit Function
errHandler:
    ErrorIn "modMain.CheckCanInsert"
End Function

Public Function InsertAllErrorHandlers() As Boolean
    Dim Cnt As Long, Msg As String, Cancelled As Boolean
    On Error GoTo errHandler
    If Not CheckCanInsert Then Exit Function
    CurrentLine = CodeStartLine
    Msg = "You are about to add error handlers to all procedures in code module " & _
        ideModuleName & ". Ok to proceed?"
    If Not AskYesNo(Msg) Then Exit Function
    SaveUndoCopy
    Do
        InsertErrorHandler True
        Cnt = Cnt + 1
    Loop Until Cnt > MAX_MEMBERS Or CurrentLine > ActiveModule.CountOfLines - 3
    If Cnt >= MAX_MEMBERS Then Say "Member count overflow."
    InsertAllErrorHandlers = True
    Exit Function
errHandler:
    ErrorIn "modMain.InsertAllErrorHandlers"
End Function

Public Sub UndoLastOperation()
    Dim Code As String
    On Error GoTo errHandler
    DeleteTextAt 1, ActiveModule.CountOfLines
    InsertTextAt 1, LoadText(UndoFileName)
    Kill UndoFileName
    Exit Sub
errHandler:
    ErrorIn "modMain.UndoLastOperation"
End Sub

Public Function UndoAvailable() As Boolean
    On Error GoTo errHandler
    If (SttLastSavedUndoModule = "") Or (ideModuleName = "") Then Exit Function
    If Dir(UndoFileName) = "" Then Exit Function
    UndoAvailable = True
    Exit Function
errHandler:
    ErrorIn "modMain.UndoAvailable"
End Function

Private Sub SaveUndoCopy()
    On Error GoTo errHandler
    SttLastSavedUndoModule = ideModuleName
    With ActiveModule
        SaveText UndoFileName, .Lines(1, .CountOfLines)
    End With
    Exit Sub
errHandler:
    ErrorIn "modMain.SaveUndoCopy"
End Sub

Private Function UndoFileName() As String
    UndoFileName = App.Path & "\HuntERRAddInUndo.txt"
End Function

Public Function RefreshCurrentProc() As Boolean
    On Error GoTo errHandler
    RefreshCurrentProc = ReadCurrentProcInfo(ProcName, procType, procIsHandler, procStartLine, procLineCount, procText)
    Exit Function
errHandler:
    ErrorIn "RefreshCurrentProc"
End Function

Public Function InsertErrorHandler(ByVal InsertingAll As Boolean) As Boolean
    On Error GoTo errHandler
    If RefreshCurrentProc Then
        ScanCurrentProc
        If InsertingAll And procIsSimpleProp And SttSimplePropNo Then
            CurrentLine = procStartLine + procLineCount
            InsertErrorHandler = True
            Exit Function
        End If
        ConstructErrorHandlerCode
        SetupErrorHandler
        If (Not InsertingAll) And SttAskConfirmation Then
            Check frmConfirmInsert.AskConfirmation(ProcNewText), EXC_CANCELLED, ""
        End If
        SaveCurrProcProps
        DeleteTextAt procStartLine, procLineCount
        InsertTextAt procStartLine, ProcNewText
        RestoreCurrProcProps
        If InsertingAll Then
            ActivePane.TopLine = procStartLine
            Else
            CurrentLine = procStartLine + procHdrEndLine + 1
        End If
        InsertErrorHandler = True
        Else 'Not ReadCurrentProcInfo(....
        InsertErrorHandler = False
        Exit Function
    End If
    Exit Function
errHandler:
    ErrorIn "modMain.InsertErrorHandler(InsertingAll)", InsertingAll
End Function

